com.fasterxml.jackson.databind.ser.impl

## Class IndexedListSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<T>
      - - com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase<List<?>>
        - - com.fasterxml.jackson.databind.ser.impl.IndexedListSerializer

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable

    public final class IndexedListSerializer
    extends AsArraySerializerBase<List<?>>

This is an optimized serializer for Lists that can be efficiently traversed by index (as opposed to others, such as `LinkedList` that cannot}.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase

`_dynamicSerializers, _elementSerializer, _elementType, _property, _staticTyping, _unwrapSingle, _valueTypeSerializer`

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
Constructor and Description
`IndexedListSerializer(IndexedListSerializer src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> valueSerializer, Boolean unwrapSingle)`
`IndexedListSerializer(JavaType elemType, boolean staticTyping, TypeSerializer vts, JsonSerializer<Object> valueSerializer)`

### Method Summary

All Methods Instance Methods Concrete Methods
`ContainerSerializer<?>` `_withValueTypeSerializer(TypeSerializer vts)` Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
`boolean` `hasSingleElement(List<?> value)` Method called to determine if the given value (of type handled by this serializer) contains exactly one element.
`boolean` `isEmpty(SerializerProvider prov, List<?> value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`void` `serialize(List<?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeContents(List<?> value, com.fasterxml.jackson.core.JsonGenerator g, SerializerProvider provider)`
`void` `serializeContentsUsing(List<?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider, JsonSerializer<Object> ser)`
`void` `serializeTypedContents(List<?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)`
`IndexedListSerializer` `withResolved(BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer, Boolean unwrapSingle)`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase

`_findAndAddDynamic, _findAndAddDynamic, acceptJsonFormatVisitor, createContextual, getContentSerializer, getContentType, getSchema, serializeWithType, withResolved`

### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

`hasContentTypeAnnotation, withValueTypeSerializer`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_neitherNull, _nonEmpty, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findContextualConvertingSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isEmpty, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### IndexedListSerializer

    public IndexedListSerializer(JavaType elemType,
                                 boolean staticTyping,
                                 TypeSerializer vts,
                                 JsonSerializer<Object> valueSerializer)

#### IndexedListSerializer

    public IndexedListSerializer(IndexedListSerializer src,
                                 BeanProperty property,
                                 TypeSerializer vts,
                                 JsonSerializer<?> valueSerializer,
                                 Boolean unwrapSingle)

### Method Detail

#### withResolved

    public IndexedListSerializer withResolved(BeanProperty property,
                                              TypeSerializer vts,
                                              JsonSerializer<?> elementSerializer,
                                              Boolean unwrapSingle)

Specified by:
  `withResolved` in class `AsArraySerializerBase<List<?>>`

#### isEmpty

    public boolean isEmpty(SerializerProvider prov,
                           List<?> value)

Description copied from class: `JsonSerializer`
Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

NOTE: replaces `JsonSerializer.isEmpty(Object)`, which was deprecated in 2.5

Overrides:
  `isEmpty` in class `JsonSerializer<List<?>>`

#### hasSingleElement

    public boolean hasSingleElement(List<?> value)

Description copied from class: `ContainerSerializer`
Method called to determine if the given value (of type handled by this serializer) contains exactly one element.

Note: although it might seem sensible to instead define something like "getElementCount()" method, this would not work well for containers that do not keep track of size (like linked lists may not).

Note, too, that as of now (2.9) this method is only called by serializer itself; and specifically is not used for non-array/collection types like `Map` or `Map.Entry` instances.

Specified by:
  `hasSingleElement` in class `ContainerSerializer<List<?>>`

#### _withValueTypeSerializer

    public ContainerSerializer<?> _withValueTypeSerializer(TypeSerializer vts)

Description copied from class: `ContainerSerializer`
Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.

Specified by:
  `_withValueTypeSerializer` in class `ContainerSerializer<List<?>>`

#### serialize

    public final void serialize(List<?> value,
                                com.fasterxml.jackson.core.JsonGenerator gen,
                                SerializerProvider provider)
                         throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Overrides:
  `serialize` in class `AsArraySerializerBase<List<?>>`
Parameters:
  `value` - Value to serialize; can not be null.
  `gen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### serializeContents

    public void serializeContents(List<?> value,
                                  com.fasterxml.jackson.core.JsonGenerator g,
                                  SerializerProvider provider)
                           throws IOException

Specified by:
  `serializeContents` in class `AsArraySerializerBase<List<?>>`
Throws:
  `IOException`

#### serializeContentsUsing

    public void serializeContentsUsing(List<?> value,
                                       com.fasterxml.jackson.core.JsonGenerator jgen,
                                       SerializerProvider provider,
                                       JsonSerializer<Object> ser)
                                throws IOException

Throws:
  `IOException`

#### serializeTypedContents

    public void serializeTypedContents(List<?> value,
                                       com.fasterxml.jackson.core.JsonGenerator jgen,
                                       SerializerProvider provider)
                                throws IOException

Throws:
  `IOException`